clear j
close all;
c = ureal('c',0.5,'range',[0 1]);
G11=tf([6 6],[1 5 6]);
G12=tf([c],[1 20]);
G21=G12;
G22=tf([0.1 1],[1 2 1]);

cr=0:0.1:1;
Nr=length(cr);
w=logspace(-5,5,101);
Nw=length(w);

G=[G11 G12;G21 G22];
G12nom=tf([c.Nominal],[1 20]);
Gnom=[G11 G12nom;G12nom G22];

for i=1:Nr
    G12=tf([cr(i)],[1 20]);
    G=[G11 G12;G12 G22];
    Wo_bound=(G-Gnom)*inv(Gnom);
    Wi_bound=inv(Gnom)*(G-Gnom);
    data_o=zeros(Nw,1);
    data_i=zeros(Nw,1);
    for k=1:Nw
        Wo_b=evalfr(Wo_bound,j*w(k));
        Wi_b=evalfr(Wi_bound,j*w(k));
        data_o(k)=norm(Wo_b);
        data_i(k)=norm(Wi_b);
    end;
    figure(1)
    loglog(w,data_o,'r');
    hold on;
    figure(2)
    loglog(w,data_i,'r');
    hold on;
end;

zz=-0.15;
pp=-50;
Wo=zpk([zz],[pp],0.03*pp/zz);
data_w=zeros(Nw,1);
for k=1:Nw
    data_w(k) = norm(evalfr(Wo,j*w(k)));
end;
figure(1);
loglog(w,data_w,'b');
xlabel('\omega')
title('Output Uncertainty')
hold off

figure(2);
loglog(w,data_w,'b');
xlabel('\omega')
title('Input Uncertainty')
hold off





